package authsvc

import (
	"errors"

	authdomain "legalgo-BE-go/internal/domain/auth"
	staffdomain "legalgo-BE-go/internal/domain/staff"
	"legalgo-BE-go/internal/utilities/utils"

	"github.com/google/uuid"
)

func (sv *impl) LoginAsStaff(spec staffdomain.StaffLogin) (string, error) {
	staff, err := sv.staffRepo.GetStaffByEmail(spec.Email)
	if err != nil {
		return "", errors.New(err.Error())
	}

	matchPassword := ComparePassword(staff.Password, spec.Password)
	if !matchPassword {
		return "", errors.New("wrong password")
	}

	authToken := authdomain.AuthToken{
		Email:     staff.Email,
		SessionID: uuid.NewString(),
		Role:      "staff",
	}

	token, err := utils.GenerateToken(authToken)
	if err != nil {
		return "", errors.New(err.Error())
	}

	return token, nil
}
